<template>
  <section class="container">
    <p class="disclaimer">
      Escolha suas preferências de armário para o sorteio
    </p>
    <div class='flex-container'>
      <div class='flex-item'
        v-for="f in features"
        :value="f.id"
        :key="f.id">
        {{ translate(mapIdToPlace(f.place_id)) }} {{ translate(mapIdToPosition(f.position_id))}}
         <specific-preference
          :id="f.id"
          :place="f.place_id"
          :position="f.position_id"
          :feature="f.id"/>
      </div>
    </div>
   </section>
</template>

<script>
import SpecificPreference from '~/components/SpecificPreference.vue'

export default {
  components: {
    SpecificPreference
  },
  computed: {
    places() {
      return this.$store.getters.reserveData.places;
    },
    positions() {
      return this.$store.getters.reserveData.positions;
    },
    features() {
      return this.$store.getters.reserveData.features;
    },
    max() {
      if (this.positions !== null && this.places !== null)
        return (this.positions.length-1) * (this.places.length-1);
      return 0;
    }
  },
  methods: {
    mapIdToPlace(id) {
      return this.places[id].place;
    },
    mapIdToPosition(id) {
      return this.positions[id].position;
    },
    translate(str) {
      const translation = {
        top: 'Superior',
        bottom: 'Inferior',
        inside: 'Dentro',
        outside: 'Fora'
      }
      if (str !== undefined)
        return translation[str];
    }
  },
  beforeCreate() {
    let ins = this;

    this.$axios({
      url: 'http://localhost:3000/features',
      method: 'get',
      headers: {
        Authorization: `Bearer ${ins.$store.getters.authToken}`
      }
    })
      .then (res => {
        let payload = {};
        payload.places = [''].concat(res.data.places);
        payload.positions = [''].concat(res.data.positions);
        payload.features = res.data.features;

        ins.$store.commit('setReserveFeatures', payload);
      })
      .catch (err => {
        // TO-DO:
        // O que fazer em caso de erro nessa request?
        console.log(err);
      });
  }
}
</script>
<style scoped>
.flex-container {
   display: flex;              /* Children use Flexbox */
  flex-direction: line;     /* Rotate Axis to Vertical */
  justify-content: center;    /* Group Children in Center */
  align-items: center;        /* Group Children in Center (on cross axis) */
  padding: 15px 0;            /* Add padding to the top/bottom */
}


.flex-item {
  background: tomato;
  font-size: 2em;
  text-align: center;
  padding: 5vh 5vh;
  margin: 5%;
}
</style>